--CREATE_VARIABLE LINK_DEP_MAIN
--select 2
--GO

--b_kir_1711
USE {Variable_TempDb}

IF exists(select * from sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DEP_MAIN]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_TempDb}].dbo.DEP_MAIN 
GO

CREATE TABLE DEP_MAIN (LINK INT)
GO


USE {Variable_WorkDb}

--  
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[XA_NEW_DEP]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[XA_NEW_DEP]

GO
CREATE PROCEDURE dbo.XA_NEW_DEP (@LINK INT OUTPUT)
AS
BEGIN

DECLARE @SQL NVARCHAR(4000)

SET @SQL = 
'INSERT INTO dbo.[DEPARTMENTS] (' +
	SUBSTRING((
		select 
			 ',' + LTRIM(RTRIM(NAME))
		from syscolumns
		where id = object_id('dbo.[DEPARTMENTS]')
			AND ISNULLABLE = 0
			AND NAME NOT IN ('LINK','STAMP')
		order by colid	
		FOR XML PATH('')
				), 2, 3000) + ')' + CHAR(13) + CHAR(10) +
'SELECT ' +				
SUBSTRING((				
		select 
			',' + LTRIM(RTRIM(NAME + ' =' + 
			CASE WHEN dbo.sysGetColumnType(id, colid) LIKE '%CHAR%' THEN 
				CASE NAME 
					WHEN 'CODE' THEN '''CODE'''
					WHEN 'NAME' THEN '''NAME'''
					WHEN 'FULL_NAME' THEN '''FULL_NAME'''
				ELSE '''''' END
			ELSE 
				CASE WHEN NAME='LINK_DEP' THEN 'dbo.getOwnDepLink()' ELSE '0' END
			END))
		from syscolumns
		where id = object_id('dbo.[DEPARTMENTS]')
			AND ISNULLABLE = 0
			AND NAME NOT IN ('LINK','STAMP')
		order by colid
		FOR XML PATH('')
				), 2, 3000) + 
'
SET @NEW = SCOPE_IDENTITY()

UPDATE dbo.DEPARTMENTS SET 
CODE = LEFT(CONVERT(VARCHAR(20),@NEW),10), 
	NAME = '' '' + LEFT(CONVERT(VARCHAR(20),@NEW),10), 
	[FULL_NAME] = '' '' + LEFT(CONVERT(VARCHAR(20),@NEW),10) 
WHERE LINK = @NEW

INSERT INTO dbo.DEPARTMENT_GROUPS_REF ([DEP_LINK],[GROUP_LINK])
SELECT @NEW, (SELECT TOP 1 LINK FROM dbo.DEPARTMENT_GROUPS WHERE SYS = 3 AND SNAME = '''')

'
PRINT @SQL

EXEC SP_EXECUTESQL @SQL, N'@NEW INT OUTPUT', @NEW = @LINK OUTPUT

END



GO


GRANT EXECUTE ON dbo.[XA_NEW_DEP] TO PUBLIC

GO


USE {Variable_TempDb}
GO

--      -
DECLARE @iLINK_DEP_MAIN INT

SELECT TOP 1 @iLINK_DEP_MAIN = dsks.LINK_NEW
FROM {Variable_SmetaDb}.dbo.DEPARTMENTS d 
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK WHERE d.[TYPE]= 4

IF @iLINK_DEP_MAIN IS NULL
BEGIN
	IF (
		SELECT COUNT(*)
		FROM {Variable_SmetaDb}.dbo.DEPARTMENTS d INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK 
		WHERE d.[TYPE]= 4 OR ZB = 1
		) = 1

		SELECT @iLINK_DEP_MAIN = dsks.LINK_NEW 
		FROM {Variable_SmetaDb}.dbo.DEPARTMENTS d INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK 
		WHERE d.[TYPE]= 4 OR ZB = 1
	
	ELSE
		--..      ,          - ,  .   
		--        
		EXEC [{Variable_WorkDb}].dbo.XA_NEW_DEP @iLINK_DEP_MAIN OUTPUT
		
END


INSERT INTO [{Variable_TempDb}].dbo.DEP_MAIN (LINK) VALUES (@iLINK_DEP_MAIN)
GO

GO

 --  
GO
CREATE_VARIABLE LINK_DEP_MAIN
SELECT TOP 1 LINK FROM [{Variable_TempDb}].dbo.DEP_MAIN
GO

--  ,  ,   
IF (
	SELECT COUNT(*)
	FROM {Variable_SmetaDb}.dbo.DEPARTMENTS d INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK 
	WHERE d.[TYPE]= 4 OR ZB = 1
	) > 1
BEGIN
	
	INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF ([DEP_LINK],[GROUP_LINK])
	SELECT {LINK_DEP_MAIN}, (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE SYS = 8)

	--  
	UPDATE d
	SET d.ZB = {LINK_DEP_MAIN}
	FROM 
		[{Variable_WorkDb}].dbo.DEPARTMENTS d
		inner join [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] do on do.LINK_NEW = d.LINK
	WHERE 
		do.LINK_NEW <> {LINK_DEP_MAIN}

END
GO

------      
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_KBK]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] ADD [LINK_OLD] INT NULL
GO

---    , , . ,   ..
--- ...   
IF NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS sa WHERE sa.LINK_DEP = {LINK_DEP_MAIN})
    EXEC [{Variable_WorkDb}].dbo.X_INIT_DEP @LINK_DEP_DST = {LINK_DEP_MAIN}, @MODE = 1
GO
