
set xact_abort on
BEGIN TRAN
USE [{Variable_TempDb}]
GO
--

INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_STRING (LINK_CHAR, LINK_INV, STRING)
SELECT
		LINK_CHAR     = c2.LINK, 
		LINK_INV      = isks.LINK_NEW, 
		STRING        = LTRIM(RTRIM(cvs.STRING))
FROM 
	{Variable_SmetaDb}.dbo.CHAR_VAL_STRING cvs
	INNER JOIN {Variable_SmetaDb}.dbo.CHARACTERISTICS c ON c.LINK = cvs.LINK_CHAR
	INNER JOIN [{Variable_WorkDb}].dbo.CHARACTERISTICS c2 ON c2.CODE = c.CODE {WORK_COLLATE}
	LEFT JOIN [{Variable_TempDb}].dbo.[__INVENTORY_SMETA_KS] isks ON isks.LINK_OLD = cvs.LINK_INV
		
DECLARE @iROWCOUNT INT
set @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "   (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

INSERT INTO {Variable_WorkDb}.dbo.SHORT_DESC (LINK_UP,BASIC_OBJ,NAME,ATTRIBUTE1,ATTRIBUTE2,ATTRIBUTE3,ATTRIBUTE4,ATTRIBUTE5,ATTRIBUTE6,QUANTITY,CODE,SUMMA)
SELECT
	B.LINK_NEW,
	ISNULL(A.[BASIC_OBJ],''),
	ISNULL(A.[NAME],''),
	ISNULL(A.[ATTRIBUTE1],''),
	ISNULL(A.[ATTRIBUTE2],''),
	ISNULL(A.[ATTRIBUTE3],''),
	ISNULL(A.[ATTRIBUTE4],''),
	ISNULL(A.[ATTRIBUTE5],''),
	ISNULL(A.[ATTRIBUTE6],''),
	ISNULL(A.[QUANTITY],0),
	ISNULL(A.[CODE],''),
	0
FROM 
	{Variable_SmetaDb}.dbo.SHORT_DESC A
	INNER JOIN {Variable_TempDb}.dbo.[__INVENTORY_SMETA_KS] B ON B.LINK_OLD = A.[LINK_UP]

SET @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "   (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

COMMIT TRAN

