
--  NOMENSEARCH
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
GO
---    ---
EXEC [{Variable_WorkDb}].dbo.XD_CORRECT_PROV_FULL_BY_XO_BUF
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_EMPL_POST
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_SUBDIV
GO

EXEC [{Variable_WorkDb}].dbo.GENERATE_ACCOUNT_SUBTREE
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'NOMENCLATURE', 'name', 2
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'post', 'name', 2
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'DEPARTMENTS', 'full_name', 5
GO

exec [{Variable_WorkDb}].dbo.GENERATE_NOMEN_SUBTREE
GO


/*   */
--
--       
EXECUTE [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KAU
GO

--    .   ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOP_CLASSIF
GO

--      ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_EKR
GO

--       ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_FIN_SOURCE
GO

--      ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KBK
GO

--    -  ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOCBASE
GO

--    -  ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_DOC_NAME_ALL
GO


/*    */
USE {Variable_WorkDb}
GO

IF OBJECT_ID('TEMPDB..#TL','U') IS NOT NULL
	DROP TABLE #TL
GO

CREATE TABLE #TL (LINK INT)
INSERT INTO #TL (LINK) SELECT LINK_NEW FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS]
GO

DECLARE @LINK_DOC_NASTR INT

SET @LINK_DOC_NASTR = 
(
	SELECT DN.LINK
	FROM {Variable_WorkDb}.dbo.DOC_NASTR DN INNER JOIN {Variable_WorkDb}.dbo.DOCUMENTS_PAY_ACC_OPTIONS N ON N.LINK_UP = DN.LINK
	WHERE DN.DEP_LINK = {Variable_WorkDb}.dbo.getOwnDepLink() AND DN.[OBJECT] = {Variable_WorkDb}.dbo.obj_id('DOCUMENTS_PAY')
)	
IF @LINK_DOC_NASTR IS NOT NULL
	EXEC {Variable_WorkDb}.dbo.XD_DOC_NASTR_SETTING_ACC_S_I @OBJ_CODE = 'XD_DOC_NASTR_SETTING_ACC', @LINK_DOC_NASTR = @LINK_DOC_NASTR, @cTable = '#TL' 

IF OBJECT_ID('TEMPDB..#TL','U') IS NOT NULL
	DROP TABLE #TL
GO


