
USE {Variable_TempDb}
GO

set xact_abort on
BEGIN TRAN

------   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__KL_KBK_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__KL_KBK_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__KL_KBK_SMETA_KS]
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__KAU_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__KAU_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__KAU_SMETA_KS]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOP_CLASSIF_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOP_CLASSIF_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DOP_CLASSIF_SMETA_KS]
GO

------      
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_KBK]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_DIVISION]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_DIVISION] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_DIVISION] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[DOP_CLASSIF]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DOP_CLASSIF DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DOP_CLASSIF ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_EXPEND]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_EXPEND] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_EXPEND] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_TARGET_ITEM]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_TARGET_ITEM] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_TARGET_ITEM] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_KD]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KD] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KD] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_PROG]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_PROG] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_PROG] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[KL_IVF]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_IVF] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_IVF] ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK2' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].KAU'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KAU] DROP COLUMN [LINK2]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KAU] ADD [LINK2] INT NULL
GO

------    
CREATE TABLE #__KL_DIVISION (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO
CREATE TABLE #__KL_EXPEND (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO
CREATE TABLE #__KL_KD (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO
CREATE TABLE #__KL_PROG (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO
CREATE TABLE #__KL_IVF (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO
CREATE TABLE #__KL_TARGET_ITEM (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
GO

DECLARE 
	@iERROR INT, 
	@iROWCOUNT INT, 
	@iLINK_DEFAULT INT, 
	@LINK_OBJ INT
	
SELECT @iLINK_DEFAULT = [{Variable_WorkDb}].dbo.getOwnDepLink()

------      
select distinct GAP.KBK, g.DEP AS DEPARTMENT
INTO #KBK_DEPARTMENT
from 
	{Variable_SmetaDb}.dbo.G_PROV G
	inner join {Variable_SmetaDb}.dbo.G_PROV1 G1 on G1.LINK_UP = G.LINK
	inner join {Variable_SmetaDb}.dbo.G_PROV2 G2 on G2.LINK_UP = G1.LINK
	inner join {Variable_SmetaDb}.dbo.G_PROV_AP GAP on GAP.LINK_UP = G2.LINK
where 
	GAP.KBK is not null

---
SELECT CODE, LINK INTO #T0 FROM [{Variable_WorkDb}].dbo.KL_KBK WHERE LINK_DEP = {LINK_DEP_MAIN}

---

--DELETE FROM [{Variable_WorkDb}].dbo.KL_KBK WHERE LINK IN (SELECT LINK_NEW FROM [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS])
  --      CODE,    
INSERT INTO [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS]([LINK_NEW],[LINK_OLD])
SELECT 
	A.LINK, kk.LINK	
FROM
	(SELECT 
		RowNumber = ROW_NUMBER () OVER (PARTITION BY kk2.LINK ORDER BY kk2.LINK),
		kk2.CODE {WORK_COLLATE} AS CODE,
		kk2.LINK
	FROM 
		{Variable_SmetaDb}.dbo.KL_KBK kk2
		LEFT JOIN [{Variable_TempDb}].dbo.[__ADMIN_BS_SMETA_KS] absks ON absks.LINK_OLD = kk2.LINK_ADM
		LEFT JOIN #KBK_DEPARTMENT kd ON kd.KBK = kk2.LINK 
		LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = kd.DEPARTMENT
	) kk
	INNER JOIN #T0 A ON A.CODE = KK.CODE	
WHERE 
	kk.RowNumber = 1
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] T WHERE T.[LINK_OLD] = kk.LINK)

---
INSERT INTO [{Variable_WorkDb}].dbo.KL_KBK
	([TYPE], CODE, SNAME, [NAME], LINK_ADM, DATEB, DATEE,LINK_DEP,[USED_ALL],[LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS]
SELECT DISTINCT
	kk.[TYPE], LTRIM(RTRIM(kk.CODE)), LTRIM(RTRIM(kk.NAME)), LTRIM(RTRIM(kk.NAME)),kk.LINK_ADM,kk.DATEB,kk.DATEE,kk.LINK_DEP,1,kk.[LINK_OLD]
FROM 
	(
	SELECT 
		RowNumber = ROW_NUMBER () OVER (PARTITION BY kk2.LINK ORDER BY kk2.LINK),
		kk2.[TYPE], 
		kk2.CODE {WORK_COLLATE} AS CODE, 
		kk2.NAME {WORK_COLLATE} AS NAME,
		LINK_ADM = absks.LINK_NEW,
		DATEB      = NULL,
		DATEE      = NULL,
		LINK_DEP   = ISNULL({LINK_DEP_MAIN},dsks.LINK_NEW),
		[LINK_OLD] = kk2.LINK
	FROM 
		{Variable_SmetaDb}.dbo.KL_KBK kk2
		LEFT JOIN [{Variable_TempDb}].dbo.[__ADMIN_BS_SMETA_KS] absks ON absks.LINK_OLD = kk2.LINK_ADM
		LEFT JOIN #KBK_DEPARTMENT kd ON kd.KBK = kk2.LINK 
		LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = kd.DEPARTMENT
	) kk	
WHERE 
	kk.RowNumber = 1
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] T WHERE T.[LINK_OLD] = kk.[LINK_OLD])
---
SET @iROWCOUNT = @@ROWCOUNT

---
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
---
SELECT @iERROR = @@ERROR
IF @iERROR <> 0
BEGIN
	ROLLBACK
	RAISERROR('     ',11,1)
END

---- KL_DIV
INSERT INTO [{Variable_WorkDb}].dbo.KL_DIVISION
	(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP, [LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO #__KL_DIVISION
SELECT  DISTINCT
	LTRIM(RTRIM(kd.CODE)), LTRIM(RTRIM(kd.NAME)), LTRIM(RTRIM(kd.LNAME)), NULL, NULL, @iLINK_DEFAULT, [LINK_OLD] = kd.LINK
FROM 
	{Variable_SmetaDb}.dbo.KL_DIVISION kd
WHERE 
	LEFT(kd.Code {WORK_COLLATE},4) NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_DIVISION)
	--AND LEN(LTRIM(RTRIM(ISNULL(kd.Code,'')))) = 4

INSERT INTO #__KL_DIVISION (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_DIVISION kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_DIVISION A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_DIVISION B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK	

---- KL_EXPEND
INSERT INTO [{Variable_WorkDb}].dbo.KL_EXPEND
(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP, GUID, [ACTION],[LINK_OLD])
		 OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
		 INTO #__KL_EXPEND
SELECT  DISTINCT
LTRIM(RTRIM(kd.CODE)), LTRIM(RTRIM(kd.NAME)), LTRIM(RTRIM(kd.LNAME)), NULL, NULL, @iLINK_DEFAULT, NULL, NULL,[LINK_OLD] = kd.LINK
FROM {Variable_SmetaDb}.dbo.KL_EXPEND kd
WHERE kd.Code {WORK_COLLATE} NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_EXPEND)

INSERT INTO #__KL_EXPEND (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_EXPEND kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_EXPEND A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_EXPEND B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK
--

---- KL_TARGET_ITEM
INSERT INTO [{Variable_WorkDb}].dbo.KL_TARGET_ITEM
(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP, GUID, [ACTION],[LINK_OLD])
		 OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
		 INTO #__KL_TARGET_ITEM
SELECT  DISTINCT
LTRIM(RTRIM(kd.CODE)), LTRIM(RTRIM(kd.NAME)), LTRIM(RTRIM(kd.NAME)), NULL, NULL, @iLINK_DEFAULT, NULL, NULL,[LINK_OLD] = kd.LINK
FROM {Variable_SmetaDb}.dbo.KL_TARGET_ITEM kd
WHERE kd.Code {WORK_COLLATE} NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_TARGET_ITEM)

INSERT INTO #__KL_TARGET_ITEM (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_TARGET_ITEM kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_TARGET_ITEM A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_TARGET_ITEM B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK


---KL_VKR
INSERT INTO [{Variable_WorkDb}].dbo.KL_VKR(LINK_KBK, Link_DIV, Link_CSR, Link_EXP)
SELECT DISTINCT
	LINK_KBK    = kksks.LINK_NEW,
	LINK_DIV    = kd2.LINK,
	LINK_CSR    = kti.LINK_NEW,
	LINK_EXP    = ke.LINK_NEW
FROM 
	{Variable_SmetaDb}.dbo.KL_VKR kv
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = kv.LINK_KBK
	LEFT JOIN {Variable_SmetaDb}.dbo.KL_DIVISION kd ON kd.LINK = kv.LINK_DIV
	LEFT JOIN [{Variable_WorkDb}].dbo.KL_DIVISION kd2 ON kd2.CODE = kd.CODE {WORK_COLLATE}
	LEFT JOIN #__KL_TARGET_ITEM kti ON kti.LINK_OLD = kv.LINK_CSR
	LEFT JOIN #__KL_EXPEND ke ON ke.LINK_OLD = kv.LINK_EXP
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.KL_VKR A WHERE A.LINK_KBK = kksks.LINK_NEW)
----

---- KL_KD
INSERT INTO {Variable_WorkDb}.dbo.KL_KD
(CODE, SNAME, NAME, LINK_OLD, LINK_DEP)
		 OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
		 INTO #__KL_KD
SELECT DISTINCT
	CODE    = LTRIM(RTRIM(kk.Code)),
	SNAME   = LTRIM(RTRIM(kk.Name)),
	NAME    = LTRIM(RTRIM(kk.LNAME)),
	LINK_OLD = kk.LINK,
	LINK_DEP = @iLINK_DEFAULT
FROM 
	{Variable_SmetaDb}.dbo.KL_KD kk
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.KL_KD B WHERE LTRIM(RTRIM(ISNULL(B.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},''))	))

INSERT INTO #__KL_KD (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_KD kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_KD A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_KD B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK	


---- KL_PROG
INSERT INTO [{Variable_WorkDb}].dbo.KL_PROG
(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP, GUID, [ACTION],[LINK_OLD])
		 OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
		 INTO #__KL_PROG
SELECT  DISTINCT
LTRIM(RTRIM(kd.CODE)), LTRIM(RTRIM(kd.NAME)), LTRIM(RTRIM(kd.LNAME)), NULL, NULL, @iLINK_DEFAULT, NULL, NULL,[LINK_OLD] = kd.LINK
FROM {Variable_SmetaDb}.dbo.KL_PROG kd
WHERE kd.Code {WORK_COLLATE} NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_PROG)

INSERT INTO #__KL_PROG (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_PROG kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_PROG A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_PROG B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK

------KL_KBK_KD
INSERT INTO [{Variable_WorkDb}].dbo.KL_KBK_KD
	(LINK_KBK, Link_KD, Link_PROG)
SELECT  DISTINCT
	LINK_KBK    = kksks.LINK_NEW,
	LINK_KD     = kkd.LINK_NEW,
	LINK_PROG   = kp.LINK_NEW
FROM {Variable_SmetaDb}.dbo.KL_KBK_KD kkk
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = kkk.LINK_KBK
	LEFT JOIN #__KL_KD kkd ON kkd.LINK_OLD = kkk.Link_KD
	LEFT JOIN #__KL_PROG kp ON kp.LINK_OLD = kkk.LINK_PROG
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.KL_KBK_KD A WHERE A.[LINK_KBK]=kksks.LINK_NEW)	

---- KL_IVF
INSERT INTO [{Variable_WorkDb}].dbo.KL_IVF
(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP, GUID, [ACTION],[LINK_OLD])
		 OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
		 INTO #__KL_IVF
SELECT  DISTINCT
LTRIM(RTRIM(kd.CODE)), LTRIM(RTRIM(kd.NAME)), LTRIM(RTRIM(kd.LNAME)), NULL, NULL, @iLINK_DEFAULT, NULL, NULL,[LINK_OLD] = kd.LINK
FROM {Variable_SmetaDb}.dbo.KL_IVF kd
WHERE kd.Code {WORK_COLLATE} NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_PROG)

INSERT INTO #__KL_IVF (LINK_OLD,LINK_NEW)
SELECT KK.LINK, MIN(A.LINK)
FROM 
	{Variable_SmetaDb}.dbo.KL_IVF kk
	INNER JOIN {Variable_WorkDb}.dbo.KL_IVF A ON LTRIM(RTRIM(ISNULL(A.CODE,''))) = LTRIM(RTRIM(ISNULL(kk.Code {WORK_COLLATE},'')))
WHERE
	NOT EXISTS (SELECT * FROM #__KL_IVF B WHERE B.LINK_OLD = KK.LINK)
GROUP BY
	KK.LINK


----- KL_KBK_IVF
INSERT INTO [{Variable_WorkDb}].dbo.KL_KBK_IVF(LINK_KBK, Link_IVF, Link_PROG)
SELECT DISTINCT
	LINK_KBK    = kksks.LINK_NEW,
	Link_IVF     = kkd.LINK_NEW,
	LINK_PROG   = kp.LINK_NEW
FROM {Variable_SmetaDb}.dbo.KL_KBK_IVF kkk
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = kkk.LINK_KBK
	LEFT JOIN #__KL_IVF kkd ON kkd.LINK_OLD = kkk.Link_IVF
	LEFT JOIN #__KL_PROG kp ON kp.LINK_OLD = kkk.LINK_PROG
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.KL_KBK_IVF A WHERE A.[LINK_KBK]=kksks.LINK_NEW)	
---

------ DOP_CLASSIF

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__DOP_CLASSIF_SMETA_KS] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.DOP_CLASSIF d
	INNER JOIN (
		SELECT [LINK], [CODE], NUM = ROW_NUMBER() OVER (PARTITION BY CODE ORDER BY LINK)
		FROM [{Variable_WorkDb}].dbo.DOP_CLASSIF
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[CODE] = LEFT(d.CODE {WORK_COLLATE},254)
--
INSERT INTO [{Variable_WorkDb}].dbo.DOP_CLASSIF
	(CODE, SNAME, [NAME], DATEB, DATEE, LINK_DEP, [GUID], [ACTION], LINK_OLD)
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
	INTO [__DOP_CLASSIF_SMETA_KS]
SELECT
	CODE    = LTRIM(RTRIM(dc.CODE)),
	SNAME   = LTRIM(RTRIM(dc.NAME)),
	[NAME]  = LTRIM(RTRIM(dc.NAME)),
	DATEB   = NULL,
	DATEE   = NULL,
	LINK_DEP= {LINK_DEP_MAIN},
	[GUID]  = NULL,
	[ACTION]= NULL,
	LINK_OLD= dc.LINK
FROM 
	{Variable_SmetaDb}.dbo.DOP_CLASSIF dc
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DOP_CLASSIF_SMETA_KS] T WHERE T.[LINK_OLD] = dc.[LINK])

--    
SET @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--
    
------ KAU
INSERT INTO [{Variable_WorkDb}].dbo.KAU
(BUDGET, CODE, SNAME, [NAME], THEMA, DATEB, DATEE, LINK_DEP, LINK2)
		 OUTPUT INSERTED.LINK, INSERTED.[LINK2]
		 INTO [{Variable_TempDb}].dbo.[__KAU_SMETA_KS]
SELECT
BUDGET  = 0,
CODE    = RIGHT(k.Code,10),
SNAME   = LEFT(k.NAME,254),
[NAME]  = LEFT(k.NAME,2000),
THEMA   = NULL,
DATEB   = NULL,
DATEE   = NULL,
LINK_DEP= {LINK_DEP_MAIN},
[LINK2] = k.LINK
FROM {Variable_SmetaDb}.dbo.KAU k

--    
SET @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    
-----   
ALTER TABLE [{Variable_WorkDb}].[dbo].[KAU] DROP COLUMN [LINK2]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[DOP_CLASSIF] DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_IVF] DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_PROG] DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KD] DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_TARGET_ITEM] DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_EXPEND] DROP COLUMN [LINK_OLD]
GO
--[LINK_OLD] -  !    
--ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] DROP COLUMN [LINK_OLD]
--GO
ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_DIVISION] DROP COLUMN [LINK_OLD]
GO



UPDATE  [{Variable_WorkDb}].[dbo].[KL_KBK] SET DATEE = '20151231' WHERE LEN(REPLACE(CODE,'.','')) = 17 AND ( DATEE IS NULL OR DATEE > '20151231' )
GO

UPDATE  [{Variable_WorkDb}].[dbo].[KL_KBK] SET DATEB = '20160101' WHERE LEN(REPLACE(CODE,'.','')) = 20 AND ( DATEB IS NULL OR DATEB < '20160101' )
GO


---   
USE {Variable_TempDb}
GO

IF OBJECT_ID('TEMPDB..#__KL_DIVISION','U') IS NOT NULL
	DROP TABLE #__KL_DIVISION
GO
IF OBJECT_ID('TEMPDB..#__KL_EXPEND','U') IS NOT NULL	
DROP TABLE #__KL_EXPEND
GO
IF OBJECT_ID('TEMPDB..#__KL_TARGET_ITEM','U') IS NOT NULL
DROP TABLE #__KL_TARGET_ITEM
GO
IF OBJECT_ID('TEMPDB..#__KL_KD','U') IS NOT NULL
DROP TABLE #__KL_KD
GO
IF OBJECT_ID('TEMPDB..#__KL_PROG','U') IS NOT NULL
DROP TABLE #__KL_PROG
GO
IF OBJECT_ID('TEMPDB..#__KL_IVF','U') IS NOT NULL
DROP TABLE #__KL_IVF
GO
IF OBJECT_ID('TEMPDB..#KBK_DEPARTMENT','U') IS NOT NULL
DROP TABLE #KBK_DEPARTMENT
GO

COMMIT TRAN
