
USE [{Variable_WorkDb}]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[F_GET_REPLACE_EXPRESSION]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION dbo.[F_GET_REPLACE_EXPRESSION]

GO
CREATE FUNCTION dbo.F_GET_REPLACE_EXPRESSION(@EXPR_NAME VARCHAR(1000), @CODE VARCHAR(100)= '')
RETURNS VARCHAR (1000)
AS
BEGIN
	DECLARE
		@i		INT
		,@i0	INT
		,@sPARSE_STR	VARCHAR(1000)
		,@iPARSE_LEN	INT
		,@sTAG_VALUE	VARCHAR(100)
		,@sNEW_TAG_VALUE	VARCHAR(100)
		,@EXPR_CODE VARCHAR(1000)
	
	SET @sPARSE_STR = @EXPR_NAME
	SET @iPARSE_LEN = LEN(@sPARSE_STR)
	SET @EXPR_CODE = ''
	SELECT @i = 1, @i0 = -1
	
	WHILE (@i < @iPARSE_LEN)
	BEGIN
		IF (SUBSTRING(@sPARSE_STR,@i,1) = '<')
		BEGIN
			--      ,     
			IF (@i0 < 0)
				SET @EXPR_CODE = SUBSTRING(@sPARSE_STR,1,@i-1)
			ELSE
				--    
				SET @EXPR_CODE = @EXPR_CODE + SUBSTRING(@sPARSE_STR,@i0+1, @i - (@i0 + 1))
			SET @i0 = @i+1
		END
		ELSE IF(SUBSTRING(@sPARSE_STR,@i+1,1) = '>')
		BEGIN
			--   
			SET @sTAG_VALUE = SUBSTRING(@sPARSE_STR,@i0, @i - @i0 + 1)
			
			--  ,    		
			SELECT 
				@sNEW_TAG_VALUE = fe.[VALUES]
			FROM dbo.FAST_EXEC fe
			WHERE fe.NAME = @sTAG_VALUE and	(fe.CODE= @CODE OR ISNULL(@CODE,'')='')
			
			--     ,    
			IF isnull(@sNEW_TAG_VALUE,'') = ''
				SET @sNEW_TAG_VALUE = @sTAG_VALUE
			
			--     
			SET @EXPR_CODE = @EXPR_CODE + '<'+@sNEW_TAG_VALUE+'>'

			SET @i0 = @i+1
		END
		--  ,      
		IF (@i0 < @iPARSE_LEN) AND (@i = @iPARSE_LEN-1)
			SET @EXPR_CODE = @EXPR_CODE + SUBSTRING(@sPARSE_STR,@i0 + 1, @i - @i0 + 1)
	
		SET @i = @i + 1
	END

	RETURN @EXPR_CODE
END
GO


GRANT EXECUTE ON dbo.[F_GET_REPLACE_EXPRESSION] TO PUBLIC
GO

set xact_abort on
BEGIN TRAN

--   
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__NDS_SHABLON_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__NDS_SHABLON_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NDS_SHABLON'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NDS_SHABLON DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NDS_SHABLON ADD [LINK_OLD] INT NULL
GO

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__NDS_SHABLON_SMETA_KS] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	D.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.[DICTIONARY_PAY_NDS] d
	INNER JOIN (
		SELECT [LINK], [SHABLON], NUM = ROW_NUMBER() OVER (PARTITION BY [SHABLON] ORDER BY LINK)
		FROM [{Variable_WorkDb}].dbo.NDS_SHABLON
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[SHABLON] = d.[SHABLON] {WORK_COLLATE}
--
INSERT INTO [{Variable_WorkDb}].dbo.NDS_SHABLON
	([NAME],[SHABLON],[LINK_DEP],[EXPR_SHABL],[NDS],[LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].[dbo].[__NDS_SHABLON_SMETA_KS]
SELECT
	[NAME] = N.NAME
	,[SHABLON] = ISNULL([N].[SHABLON],'')
	,[LINK_DEP] = {LINK_DEP_MAIN}
	,[EXPR_SHABL] = [{Variable_WorkDb}].dbo.F_GET_REPLACE_EXPRESSION(ISNULL(N.[SHABLON],''),'')
	,[NDS] = NULL
	,[LINK_OLD] = N.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.[DICTIONARY_PAY_NDS] N
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__NDS_SHABLON_SMETA_KS] T WHERE T.LINK_OLD = N.LINK)

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].NDS_SHABLON DROP COLUMN [LINK_OLD]
GO
COMMIT TRAN